<br/>
<div align="center">
<a href="https://github.com/ShaanCoding/ReadME-Generator">
<img src="https://minecraft.wiki/images/Crafter_JE4_BE3.png?3996e&format=original" alt="Logo" width="80" height="80">
</a>
<h3 align="center">EasyMinecraftServer</h3>
<p align="center">
An app written in Python to make creating servers easy for both beginners and advanced users
<br/>
<br/>
<a href="https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer/wiki"><strong>Explore the docs »</strong></a>
<br/>
<br/>
<a href="https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer">View Demo .</a>  
<a href="https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer/issues/new">Report Bug .</a>
<a href="https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer/issues/new">Request Feature</a>
</p>
</div>

## About The Project

![EasyMinecraftServer's configure command being used to create a settings file in the users home directory](https://cdn.nucc.tr/assets/emc-demo.png)

This is a simple project that lets you create Minecraft Server with ease. This simple app just downloads a Server JAR for you and changes some settings so that your server is secure and fast by default. This utility does not have management abilities however that is somewhere on the backlog and is pretty far from being made.
### Built With

- [Python](https://www.python.org/)
- [Poetry](https://python-poetry.org/)
- [Typer](https://typer.tiangolo.com/)
- [pathvalidate](https://github.com/thombashi/pathvalidate)
- [psutil](https://github.com/giampaolo/psutil)
## Getting Started

This is an example of how you may give instructions on setting up your project locally.
To get a local copy up and running follow these simple example steps.
### Prerequisites

This is an example of how to list things you need to use the software and how to install them.

- Poetry (Linux)
   ```sh
   curl -sSL https://install.python-poetry.org | python3 -
   ```
- Poetry (Windows)
   ```sh
   (Invoke-WebRequest -Uri https://install.python-poetry.org -UseBasicParsing).Content | py -
   ```
### Installation

#### Development
1. Clone the repo
   ```sh
   git clone https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer.git
   ```
2. Activate Virtual Enviroment  

   Bash / Zsh / Csh
   ```sh
   eval $(poetry env activate)
   ```
   Fish
   ```sh
   eval (poetry env activate)
   ```
3. Install dependencies
   ```sh
   poetry install
   ```
#### Production
1. Download from PyPI however you would like to.  
   Example:
   ```sh
   pip install EasyMinecraftServer
   ```
## Roadmap

Moved [TODO.md](./TODO.md)

See the [open issues](https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer/issues) for a full list of proposed features (and known issues).
## Contributing

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated**.

If you have a suggestion that would make this better, please fork the repo and create a pull request. You can also simply open an issue with the tag "enhancement".
Don't forget to give the project a star! Thanks again!

All commits must follow the Conventional Commits specification and any version bumps must follow the SemVer specification

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'feat: Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request
## License

Distributed under the GPLv3 License. See [GPLv3 License](https://www.gnu.org/licenses/gpl-3.0.en.html) for more information.
## Contact

Rüzgar Engür - [@nucceteere.xyz](https://bsky.app/profile/nucceteere.xyz) - ruzgar@nucceteere.xyz

Project Link: [Funtimes909 Git](https://git.funtimes909.xyz/Nucceteere/EasyMinecraftServer)
## Acknowledgments


- [makeread.me by ShaanCoding](https://github.com/ShaanCoding/ReadME-Generator)
- [NodeJS Minecraft Versions by Nixinova](https://github.com/Nixinova/Minecraft-Versions)
- [setup.md Docs](https://www.setup.md/docs)
- [Minecraft Server Software by LeStegii](https://github.com/LeStegii/server-software)
